package com.eladit.hb9eik.blueduo;

import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.graphics.PorterDuff;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;
import android.widget.AbsoluteLayout;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.content.DialogInterface.OnClickListener;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.nio.channels.Pipe;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.Set;
import java.util.UUID;


public class MainActivity extends AppCompatActivity {

    private static final int RESULT_SETTINGS = 1;
    private static final int WAIT_CMD=0;
	private static final int DECODE_CMD_0=1;
	private static final int DECODE_CMD=3;
	private static final int TEST_CMD=10;
    private static final int X_min = 0;
    private static final int X_max = 1024;
    private static final int Y_min = -160;
    private static final int Y_max = 0;
    private static final int Y_min_z = -130;
    private static final int Y_max_z = -50;
    private static final int Div = 9;
    private static final int initNr=-2;
    private static final int initNb=-2;
    private static final int initAn=-1;
    private static final int initRit=-1;
    private static final int initLp=-1;
    private static final int initAtt=-1;
    private static final int initSquelch=-5;
    private static final int initVolume=50;
    private static final int initVolumeAux=50;
    private static final int initVolumeSide=50;
    private BluetoothAdapter mBluetoothAdapter;
    private char Cmd=0xFF;
    //private char Cmd1=0xFF;
    private char SubCmd=0xFF;
    private int DataLength = 0;
    //private int DataLength1 = 0;
    //private String myLength;
    private LinearLayout sl;
    private int cnt=0;
	private long tuningFrequency, tuningFrequencyRx, tuningFrequencyA, tuningFrequencyB;
    private int tune, split, splitSA, ptttune;
    private int cwMute, phMute;
    private TextView myText, txt_freq;
    private Context context;
    private ArrayList<band> bands;
    private band newBand=null;
    private myButton bandButton=null;
    private ArrayList<myButton> normali;
    private ArrayList<myButton> numeri;

	private char SerialProcessStatus=WAIT_CMD;
    private boolean isConnected=Boolean.FALSE;
    private BluetoothDevice myDevice;
    private BluetoothSocket mySocket;
    private UUID myUuid;
    private InputStream myIn, myFakeIn;
    private OutputStream myOut=null, myFakeOut=null;
    private Thread myLoop;
    private Thread myFakeLoop;
	private Handler mHandler = new Handler();
    private float[] xvalues = new float[X_max];
    private float[] yvalues = new float[X_max];
    private NumberFormat freqFormat = new DecimalFormat("###,###,###");
    private NumberFormat ritFormat = new DecimalFormat("###,###");
    private String newFreq = "";
    private myLabel freqLabel, newFreqLabel, eladLabel;
    private byte[] myState = new byte[37];
    private int screenHeight, screenWidth;
    private slider slider;

    private int mainVol, auxVol, volume=initVolume;
    private int volumeRx, volumeAux, volumeSide;
    private int indVol;
    private int duoType, vfoUsed, vfoSent;
    private int mode, modeRx, modeA, modeB;
    private int LSBbw, USBbw,CWbw,AMbw, FMbw, sideTone, sideVol;
    private int ptt, squelch=initSquelch;
    private int nr=initNr, nb=initNb, an=initAn;
    private int rssi;
    private int agcAuto, agcAlvl, agcMlvl, agcThr, agc;
    private int rit=initRit, lp=initLp, att=initAtt;
    private int pitch;
    private long freq=0, oldfreq=0, ritFreq=0;
    private char[] ritStr;

    private byte[] rbuf;

    private String bwCW[]={ " ", "2600 Hz", "1500 Hz", "1000 Hz", "500 Hz", "300 Hz", "100 Hz", "100a", "100b", "100c", "100d" };
    private String bwAM[]={ " ", "2500 Hz", "3000 Hz", "3500 Hz", "4000 Hz", "4500 Hz", "5000 Hz", "5500 Hz", "6000 Hz" };
    private String bwFM[]={ " ", "Nar", "Wide", "Data" };
    private String bwSSB[]={ " ", "1600 Hz", "1700 Hz", "1800 Hz", "1900 Hz", "2000 Hz", "2100 Hz", "2200 Hz", "2300 Hz", "2400 Hz", "2500 Hz", "2600 Hz",
        "2700 Hz", "2800 Hz", "2900 Hz", "3000 Hz", "3100 Hz", "4000 Hz", "5000 Hz", "6000 Hz", "D300", "D600", "D1000" };


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        screenWidth=this.getResources().getDisplayMetrics().widthPixels;
        screenHeight=this.getResources().getDisplayMetrics().heightPixels;

        int resourceId = getResources().getIdentifier("status_bar_height", "dimen", "android");
        if (resourceId > 0) {
            screenHeight -= getResources().getDimensionPixelSize(resourceId);
        }

        context=this.getApplicationContext();

        myText = (TextView) findViewById(R.id.myText);
        int width=screenWidth;
        int height=screenHeight/10;
        int left=0;
        int top=screenHeight/10;
        myText.setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        myText.refreshDrawableState();

        AbsoluteLayout al = (AbsoluteLayout) findViewById(R.id.first);

        bands=new ArrayList<band>(11);
        bands.add( new band(  1800000,  2000000,  1910000,2,"160m"));
        bands.add( new band(  3500000,  3900000,  3690000,2, "80m"));
        bands.add( new band(  7000000,  7200000,  7090000,2, "40m"));
        bands.add( new band( 10100000, 10150000, 10116000,2, "30m"));
        bands.add( new band( 14000000, 14350000, 14285000,3, "20m"));
        bands.add( new band( 18068000, 18168000, 18130000,3, "17m"));
        bands.add( new band( 21000000, 21450000, 21285000,3, "15m"));
        bands.add( new band( 24890000, 24990000, 24950000,3, "12m"));
        bands.add( new band( 28000000, 29700000, 28360000,3, "10m"));
        bands.add( new band( 50000000, 52000000, 50110000,3,  "6m"));
        bands.add( new band(144000000,146000000,144200000,3,  "2m"));
        bands.add( new band( 88000000,108000000, 88100000,5,  "FM"));

        for( int j=0; j<bands.size(); j++ ) {
            band ba = bands.get(j);
            ba.setNb(initNb);
            ba.setNr(initNr);
            ba.setAn(initAn);
            ba.setSq(initSquelch);
        }

        eladLabel = new myLabel(context, al, screenHeight, screenWidth, 2000, " ELAD",  0,  0, 20, 0xFFFFFFFF, 0xFF0000FF, Gravity.CENTER_VERTICAL | Gravity.LEFT, 16, this, true );
        freqLabel = new myLabel(context, al, screenHeight, screenWidth, 2002, "Freq.", 0, 20, 40, 0xFFFFFFFF, 0xFF0000FF, Gravity.CENTER_VERTICAL | Gravity.CENTER_HORIZONTAL, 16, this, true );
        newFreqLabel = new myLabel(context, al, screenHeight, screenWidth, 2102, "New Freq", 0, 20, 40, 0xFFFFFFFF, 0xFF0000FF, Gravity.CENTER_VERTICAL | Gravity.CENTER_HORIZONTAL, 16, this, false );
        new myLabel(context, al, screenHeight, screenWidth, 2001, "Rit. ", 0, 60, 20, 0xFFFFFFFF, 0xFF0000FF, Gravity.CENTER_VERTICAL | Gravity.RIGHT, 14, this, true );

        new myLabel(context, al, screenHeight, screenWidth, 2004, "Vol",   1,  0,  7, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2005, "Mod",   1,  7,  4, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2003, "BW ",   1, 11, 11, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL ,12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2006, "NR ",   1, 22,  7, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2007, "NB ",   1, 29,  7, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2008, "AN ",   1, 36,  7, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2009, "Att ",  1, 43,  7, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2012, "Lp ",   1, 50,  7, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2010, "AGC ",  1, 57, 12, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );
        new myLabel(context, al, screenHeight, screenWidth, 2011, "Sq ",   1, 69, 11, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 12, this, true );

        new myLabel(context, al, screenHeight, screenWidth, 3001, "",             2, 72,  8, 0xFFFFFFFF, 0xFF000000, Gravity.CENTER_VERTICAL, 10, this, true );

        normali=new ArrayList<myButton>(15);
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1001, "PTT",  3, 11, 0xFFFF0000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1002, "TUNE", 3, 12, 0xFF004400, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1003, "CW-",  3, 13, 0xFF000000, this, true ) );
        new myButton(context, al, screenHeight, screenWidth, 1004, "CW+",  3, 14, 0xFF000000, this, true );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1005, "6m",   4, 11, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1006, "2m",   4, 12, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1007, "MUTE", 4, 13, 0xFF000000, this, true ) );
        new myButton(context, al, screenHeight, screenWidth, 1008, "LSB",  4, 14, 0xFF000000, this, true );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1009, "15m",  5, 11, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1010, "12m",  5, 12, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1011, "10m",  5, 13, 0xFF000000, this, true ) );
        new myButton(context, al, screenHeight, screenWidth, 1012, "USB",  5, 14, 0xFF000000, this, true );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1013, "30m",  6, 11, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1014, "20m",  6, 12, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1015, "17m",  6, 13, 0xFF000000, this, true ) );
        new myButton(context, al, screenHeight, screenWidth, 1061, "AM",   6, 14, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1024, "LP",   7,  0, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1022, "Att",  7,  1, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1022, "NR",   7,  4, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1023, "NB",   7,  3, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1024, "AN",   7,  2, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1025, "MGC",  7,  5, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1025, "AGC",  7,  6, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1025, "Thr",  7,  7, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1026, "RIT",  7,  8, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1027, "SQ",   7,  9, 0xFF000000, this, true );
        new myButton(context, al, screenHeight, screenWidth, 1028, "BW",   7, 10, 0xFF000000, this, true );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1017, "160m", 7, 11, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1018, "80m",  7, 12, 0xFF000000, this, true ) );
        normali.add( new myButton(context, al, screenHeight, screenWidth, 1029, "40m",  7, 13, 0xFF000000, this, true ) );
        new myButton(context, al, screenHeight, screenWidth, 1020, "FM",   7, 14, 0xFF000000, this, true );

        numeri=new ArrayList<myButton>(15);
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1101, "1",    3, 11, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1102, "2",    3, 12, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1103, "3",    3, 13, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1104, "4",    4, 11, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1105, "5",    4, 12, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1106, "6",    4, 13, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1107, "7",    5, 11, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1108, "8",    5, 12, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1109, "9",    5, 13, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1110, "Abort",6, 11, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1111, "0",    6, 12, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1112, "Del",  6, 13, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1101, "MHz",  7, 11, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1102, "KHz",  7, 12, 0xFF0000FF, this, false ) );
        numeri.add( new myButton(context, al, screenHeight, screenWidth, 1103, "Hz",   7, 13, 0xFF0000FF, this, false ) );

        LinearLayout sm = (LinearLayout) findViewById(R.id.smeter);
        width=screenWidth*2/14;
        height=screenHeight*2/16;
        left=screenWidth*45/60;
        top=screenHeight*7/32;
        sm.setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        sm.refreshDrawableState();
        plot smeter = new plot(this,height,width);
        smeter.setId(300);
        sm.addView(smeter);
        smeter.NewData(0,0);

        LinearLayout lp = (LinearLayout) findViewById(R.id.graphcontainer);
        width=screenWidth*11/15;
        height=screenHeight*21/32;
        left=0;
        top=screenHeight*7/32;
        lp.setLayoutParams( new AbsoluteLayout.LayoutParams(width, height, left, top));
        lp.refreshDrawableState();

        plot2d graph = new plot2d(this,xvalues,yvalues,1,height,width);
        for (int i = 0; i < X_max; i++) {
            xvalues[i] = (float) i;
        }
        graph.watrfalactive = 1;
        graph.minx = X_min;
        graph.maxx = X_max;
        graph.maxy = Y_max;
        graph.miny = Y_min;
        graph.maxyz = Y_max_z;
        graph.minyz = Y_min_z;
        graph.screenWidth = screenWidth;
        graph.dx = Div;
        graph.setOnTouchListener(graph);
        graph.setId(200);
        lp.addView(graph);
        graph.setApp(this);
        graph.NewData(xvalues, yvalues);
        // lp.setVisibility(View.INVISIBLE);

        // sl = (LinearLayout)new LinearLayout(this);
        // sl.setBackgroundColor(Color.WHITE);
        // sl.setOrientation(LinearLayout.HORIZONTAL);
        // sl.setLayoutParams( new AbsoluteLayout.LayoutParams(100,100,10,10) );
        sl = (LinearLayout) findViewById(R.id.slider);
        width=screenWidth*4/15;
        height=screenHeight*1/8;
        sl.setVisibility(View.VISIBLE);
        slider = new slider(this,height,width);
        slider.setOnTouchListener(slider);
        slider.setId(666);
        sl.addView(slider);
        slider.NewData( -1, 10, null, null, 0, null );
        sl.refreshDrawableState();

        // get service
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if (mBluetoothAdapter == null) {
            AlertBox("Fatal Error", " - Device does not support Bluetooth");
        }
        myText.setText("Started"+Integer.toString(screenHeight)+"-"+Integer.toString(screenWidth));
    }


    @Override
    public void onResume() {
        super.onResume();
        String subError= new String("");

        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

        Set<BluetoothDevice> pairedDevices = mBluetoothAdapter.getBondedDevices();

        // If there are paired devices
        myText.append(" - Paired");

        if (pairedDevices.size() > 0) {
            // Loop through paired devices
            myText.append(" - Search");
            myText.setVisibility(View.INVISIBLE);
            for (BluetoothDevice device : pairedDevices) {
                if (device.getName().equals(getString(R.string.BlueDuo))) {
                    myText.append(" - Discovered");
                    myDevice = device;
                    try {
                        UUID myUuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
                        mySocket = myDevice.createInsecureRfcommSocketToServiceRecord(myUuid);
                        myText.append(" - Socket created");
                    } catch (IOException e) {
                        // AlertBox("Fatal Error", "Socket creation error\n" + e.toString());
                        subError = "Socket creation error\n" + e.toString()+"\n";
                        break;
                    }
                    mBluetoothAdapter.cancelDiscovery();
                    myText.append(" - Discovery cancelled");
                    try {
                        mySocket.connect();
                        myText.append(" - Connected");
                    } catch (IOException e) {
                        // AlertBox("Fatal Error", "Connect error\n" + e.toString());
                        subError = "Connect error\n" + e.toString()+"\n";
                        break;
                    }
                    try {
                        myIn = mySocket.getInputStream();
                        myText.append(" - GetInputStream");
                    } catch (IOException e) {
                        // AlertBox("Fatal Error", "GetInputStream error\n" + e.toString());
                        subError = "GetInputStream error\n" + e.toString()+"\n";
                        break;
                    }
                    try {
                        myOut = mySocket.getOutputStream();
                        myText.append(" - GetOutputStream");
                    } catch (IOException e) {
                        // AlertBox("Fatal Error", "GetOutputStream error\n" + e.toString());
                        subError = "GetOutputStream error\n" + e.toString()+"\n";
                        break;
                    }
                    myLoop = new mLoopdati(myIn, myOut);
                    myText.append(" - StartingLoop");
                    myLoop.start();
                    isConnected=Boolean.TRUE;
                    break;
                }
            }
            if(!isConnected) {
                // AlertBox("Warning", "No ELAD device found");
                subError = subError+"No ELAD device found\n";
            }
        }
        if ( pairedDevices.size() == 0 || !isConnected ) {
            AlertBox("Warning", "No devices found o no bluetooth activated\n"+subError+"Running in demo mode");
            eladLabel.setText("ELAD DEMO");
            PipedOutputStream fakeDuoout = new PipedOutputStream();
            PipedOutputStream fakeTabletout = new PipedOutputStream();
            try {
                PipedInputStream fakeDuoin = new PipedInputStream( fakeTabletout );
                PipedInputStream fakeTabletin = new PipedInputStream( fakeDuoout );
                myFakeLoop = new mFakeLoopdati( fakeDuoin, fakeDuoout );
                myFakeLoop.start();
                myLoop = new mLoopdati(fakeTabletin, fakeTabletout);
                myLoop.start();
            } catch( IOException e ) {}
        }
    }

    @Override
    public void onStop() {
        if( isConnected ) {
            myLoop.interrupt();
        }
        System.exit(0);
        super.onStop();
    }
    public slider getSlider() { return this.slider; }
    public LinearLayout getSl() { return this.sl; }
    public int getScreenHeight() { return this.screenHeight; }
    public int getScreenWidth() { return screenWidth; }
    public byte[] getMyState() { return myState; }
    public OutputStream getOutStream() {
        return myOut;
    }
    public NumberFormat getFreqFormat() {
        return freqFormat;
    }
    public myLabel getFreqLabel() {
        return freqLabel;
    }
    public myLabel getNewFreqLabel() {
        return newFreqLabel;
    }
    public List<band> getBands() {
        return bands;
    }
    public ArrayList<myButton> getNormali() {
        return normali;
    }
    public ArrayList<myButton> getNumeri() {
        return numeri;
    }
    public String getNewFreq() {
        return newFreq;
    }
    public int getAgcAuto() {
        return agcAuto;
    }
    public int getAgc() {
        return agcAlvl;
    }
    public int getMgc() {
        return agcMlvl;
    }
    public int getThr() {
        return agcThr;
    }
    public int getNb() {
        return nb;
    }
    public void setNb(int nb) {
        this.nb=nb;
    }
    public int getNr() {
        return nr;
    }
    public void setNr(int nr) {
        this.nr=nr;
    }
    public int getAn() {
        return an;
    }
    public void setAn(int an) {
        this.an=an;
    }
    public int getRit() {
        return rit;
    }
    public void setRit(int rit) {
        this.rit=rit;
    }
    public int getMod() {
        return mode;
    }
    public void setMod(int mode) {
        this.mode=mode;
    }
    public int getSq() {
        return squelch;
    }
    public void setSq(int sq) {
        this.squelch=sq;
    }
    public int getVolume() {
        return volume;
    }
    public long getFreq() {
        return freq;
    }
    public int getAtt() {
        return att;
    }
    public void setNewFreq( String freq ) {
        newFreq=freq;
    }
    public void setAtt(int att) {
        this.att=att;
    }
    public int getLp() {
        return lp;
    }
    public void setLp(int lp) {
        this.lp=lp;
    }
    public void setNewBand( band newBand, myButton bandButton ){
        this.newBand=newBand;
        this.bandButton=bandButton;
    }
    public void setFreq(int freq, band newBand, myButton bandButton ) {
        if( newBand!=null && bandButton!=null ) {
            this.newBand = newBand;
            this.bandButton = bandButton;
        }
        String catcmd = String.format("CF%011d;",freq);
        int myFreq=freq;
        for( int j=14; j>5; j-- ) {
            myState[j]=(byte)((myFreq &0x0F)|0x30);
            myFreq >>= 4;
        }
        try {
            if(this.myOut != null ) {
                this.myOut.write(catcmd.getBytes());
                this.myOut.flush();
            }
        } catch (IOException e) {
            AlertBox("Error", "Serial cat send error\n" + catcmd + "\n" + e.toString());
        }
    }
    void setBand( long oldFreq, band newBand ) {
        List<band> bands=this.bands;
        band from=null;
        for( int j=0; j<bands.size(); j++ ) {
            band ba = bands.get(j);
            if (ba.getStart() <= oldFreq && ba.getEnd() >= oldFreq) {
                from = ba;
            }
            if (from != null) {
                break;
            }
        }
        if( from != null ) {
            from.setFreq((int) oldFreq);
            from.setNr(this.nr);
            from.setNb(this.nb);
            from.setAn(this.an);
            from.setSq(this.squelch);
            from.setMod(this.mode);
            if( newBand != null && bandButton != null ) {
                if ("2m".equals(from.getName()) && !"2m".equals(newBand.getName())) {
                    this.bandButton.from2m();
                }
            }
        }
    }
    int getBw(){
        switch( mode ) {
            case 1:
                return AMbw;
            case 2:
                return LSBbw;
            case 3:
                return USBbw;
            case 4:
                return CWbw;
            case 5:
                return FMbw;
            case 6:
                return CWbw;
            default:
                return 0;
        }
    }
    int getBwl(){
        switch( mode ) {
            case 1:
                return 8;
            case 2:
                return 22;
            case 3:
                return 22;
            case 4:
                return 10;
            case 5:
                return 3;
            case 6:
                return 10;
            default:
                return 0;
        }
    }
    int getBws(){
        switch( mode ) {
            case 1:
                return 0;
            case 2:
                return 0;
            case 3:
                return 0;
            case 4:
                return 7;
            case 5:
                return 0;
            case 6:
                return 7;
            default:
                return 0;
        }
    }
    public void setAll( band newBand, myButton button ){
        setNr(-newBand.getNr());
        button.NRdown();
        setNb(-newBand.getNb());
        button.NBdown();
        setAn(-newBand.getAn());
        button.ANdown();
        setSq(-newBand.getSq());
        button.SQdown();
        button.SQup();
        int mod=newBand.getMod();
        setMod(mod);
        String catCmd;
        switch( mod ) {
            case 1:
                catCmd="MD5;";
                break;
            case 2:
                catCmd="MD1;";
                break;
            case 3:
                catCmd="MD2;";
                break;
            case 4:
                catCmd="MD3;";
                break;
            case 5:
                catCmd="MD4;";
                break;
            case 6:
                catCmd="MD7;";
                break;
            default:
                catCmd="";
        }
        button.sendCmd( catCmd );
        catCmd="GM000;";
        button.sendCmd( catCmd );
        setNewBand(null, null);
    }

    public void setVolume(int volume) {
        this.volume=volume;
    }
    public int getPtt() {
        return ptt;
    }
    public int getTune() {
        return tune;
    }
    public int getResultSettings() {
        return RESULT_SETTINGS;
    }

    public void AlertBox( String title, String message ){
        new AlertDialog.Builder(this)
                .setTitle( title )
                .setMessage( message + "\nPress OK to dismiss." )
                .setPositiveButton("OK", new OnClickListener() {
                    public void onClick(DialogInterface arg0, int arg1) {
                        isConnected = Boolean.FALSE;
                        // finish();
                    }
                }).show();
    }

	private class mLoopdati extends Thread {
        private InputStream inS;
        private OutputStream outS;

        public mLoopdati(InputStream in, OutputStream out) {
            myText.append(" - InitLoop");
            inS = in;
            outS = out;
        }

        public void run() {
            int i, idx = 0;
            int len;
            rbuf = new byte[8096];
            byte[] rbufCmd = new byte[1];

            myText.append(" - LoopStarted");

            for (; ; ) {//this is the main loop for transferring
                switch (SerialProcessStatus) {
                    case TEST_CMD:
                        break;
                    case WAIT_CMD:
                        try {
                            len = inS.read(rbufCmd, 0, 1);
                        } catch (IOException e1) {
                            len = 0;
                        }
                        if (len > 0) {
                            if (rbufCmd[0] == 0 || rbufCmd[0] == 1) {
                                Cmd = (char) rbufCmd[0];
                                SerialProcessStatus = DECODE_CMD_0;
                            }
                        }
                        break;
                    case DECODE_CMD_0:
                        for (int j = 0; j < 5; j += len) {
                            try {
                                len = inS.read(rbuf, j, 5-j);
                            } catch (IOException e1) {
                                SerialProcessStatus = WAIT_CMD;
                                break;
                            }
                        }
                        if( SerialProcessStatus == WAIT_CMD) {
                            break;
                        }
                        char DataLengthStr[] = new char[4];
                        DataLengthStr[0] = (char) (rbuf[4] | 0x30);
                        DataLengthStr[1] = (char) (rbuf[3] | 0x30);
                        DataLengthStr[2] = (char) (rbuf[2] | 0x30);
                        DataLengthStr[3] = (char) (rbuf[1] | 0x30);
                        DataLength = 0;
                        DataLength |= DataLengthStr[0] - 0x30;
                        for (i = 1; i < 4; i++) {
                            DataLength <<= 4;
                            DataLength |= DataLengthStr[i] - 0x30;
                        }
                        SubCmd = (char) rbuf[0];
                        SerialProcessStatus = DECODE_CMD;
                        break;
                    case DECODE_CMD:
                        switch (Cmd) {
                            case 0x00: //Spettro
                                if (SubCmd == 0x30) {    //Spettro RF
                                    for (int j = 0; j < DataLength; j += len) {
                                        try {
                                            len = inS.read(rbuf, j, DataLength - j);
                                        } catch (IOException e1) {
                                            SerialProcessStatus = WAIT_CMD;
                                            break;
                                        }
                                    }
                                    if (SerialProcessStatus == WAIT_CMD) {
                                        break;
                                    }
                                    for (idx = 0; idx < DataLength; idx++) {
                                        int r = rbuf[idx] & 0xFF;
                                        yvalues[idx] = (float) (r - 192.0);
                                    }
                                    mHandler.post(new Runnable() {
                                        public void run() {
                                            plot2d gr = (plot2d) findViewById(200);
                                            //gr.putOutS(outS);
                                            gr.putTuningFrequency(tuningFrequency);
                                            gr.putRit(ritFreq);
                                            gr.putPitch(pitch,mode==4,mode==6); // 4=CW+ 6=CW-
                                            gr.NewData(xvalues, yvalues);
                                            gr.refreshDrawableState();
                                        }
                                    });
                                    SerialProcessStatus = WAIT_CMD;
                                }
                                break;
                            case 0x01:
                                 if (SubCmd == 0x31) { // Radio data
                                    for( int j=0; j<DataLength; j+=len ) {
                                        try {
                                            len = inS.read(rbuf, j, DataLength-j);
                                        } catch (IOException e1) {
                                            SerialProcessStatus = WAIT_CMD;
                                            break;
                                        }
                                    }
                                    if( SerialProcessStatus == WAIT_CMD) {
                                        break;
                                    }
                                    duoType = ( rbuf[0] & 0x40 ) >> 6;
                                    vfoUsed = ( rbuf[0] & 0x20 ) >> 5;
                                    vfoSent = ( rbuf[0] & 0x10 ) >> 4;
                                    char tuningFrequencyStr[] = new char[9];
                                    //tuningFrequencyStr[0] = (char) (rbuf[0] | 0x30);
                                    tuningFrequencyStr[0] = (char) 0x30;
                                    tuningFrequencyStr[1] = (char) (rbuf[1] | 0x30);
                                    tuningFrequencyStr[2] = (char) (rbuf[2] | 0x30);
                                    tuningFrequencyStr[3] = (char) (rbuf[3] | 0x30);
                                    tuningFrequencyStr[4] = (char) (rbuf[4] | 0x30);
                                    tuningFrequencyStr[5] = (char) (rbuf[5] | 0x30);
                                    tuningFrequencyStr[6] = (char) (rbuf[6] | 0x30);
                                    tuningFrequencyStr[7] = (char) (rbuf[7] | 0x30);
                                    tuningFrequencyStr[8] = (char) (rbuf[8] | 0x30);
                                    tuningFrequencyRx = 0;
                                    tuningFrequencyRx |= tuningFrequencyStr[0] - 0x30;
                                    for (i = 1; i < 9; i++) {
                                        tuningFrequencyRx <<= 4;
                                        tuningFrequencyRx |= tuningFrequencyStr[i] - 0x30;
                                    }
                                    if( vfoSent == 0 ) {
                                        tuningFrequencyA = tuningFrequencyRx;
                                    } else {
                                        tuningFrequencyB = tuningFrequencyRx;
                                    }
                                    if( vfoUsed == 0 ) {
                                        tuningFrequency = tuningFrequencyA;
                                    } else {
                                        tuningFrequency = tuningFrequencyB;
                                    }
                                    final String mFreq = "Frequency: " + freqFormat.format(tuningFrequency) + " Hz";
                                    oldfreq=freq;
                                    freq=tuningFrequency;
                                    if( DataLength>9 && (rbuf[9]&0x80)==0x80 ) {
                                        tune = ( rbuf[9] & 0x40 ) >> 6;
                                        split = ( rbuf[9] & 0x20 ) >> 5;
                                        splitSA = ( rbuf[9] & 0x10 ) >> 4;
                                        modeRx = rbuf[9] & 0x0F;
                                        if( vfoSent == 0 ) {
                                            modeA = modeRx;
                                        } else {
                                            modeB = modeRx;
                                        }
                                        if( vfoUsed == 0 ) {
                                            mode = modeA;
                                        } else {
                                            mode = modeB;
                                        }
                                    }
                                    if( DataLength>10 && (rbuf[10]&0xC0)==0x40 ) {
                                        indVol = (rbuf[10] & 0x30 ) >> 4;
                                        int j = ((rbuf[10] & 0x08)>>3);
                                        mainVol = j>0?-1:1;
                                        j = (rbuf[10] & 0x04)>>2;
                                        auxVol  = j>0?-1:1;
                                        j = (rbuf[10] & 0x02)>>1;
                                        sideVol= j>0?-1:1;
                                        j = rbuf[10] & 0x01;
                                        ptt = j>0?j:-1;
                                    }
                                    if( DataLength>11 && (rbuf[11]&0xC0)==0x40 ) {
                                        int j = rbuf[11] & 0x0F;
                                        squelch = j > 0 ? j: squelch < 0 ? squelch : -squelch;
                                        if( squelch==0 ){
                                            squelch=initSquelch;
                                        }
                                        ptttune= (rbuf[11]&0x10)>>4;
                                    }
                                    if( DataLength>13 && (rbuf[12]&0x80)==0x80 && (rbuf[13]&0xc0)==0x40 ) {
                                        agcAuto = (rbuf[12] & 0x04)>>2;
                                        int k = rbuf[12] & 0x03;
                                        agcAlvl = k > 0 ? k: agcAlvl < 0 ? agcAlvl : -agcAlvl;
                                        k = ( rbuf[12] >> 3 ) & 0x0F;
                                        agcThr = k > 0 ? k: agcThr < 0 ? agcThr : - agcThr;
                                        cwMute = (rbuf[13] & 0x20) >> 5;
                                        phMute = (rbuf[13] & 0x10) >> 4;
                                        int l = rbuf[13] & 0x0F;
                                        agcMlvl = l > 0 ? l: agcMlvl < 0 ? agcMlvl : -agcMlvl;
                                        agc = agcAuto ==0 ? k+1 : l+5;
                                    }
                                    if( DataLength>14 && (rbuf[14]&0xF0)==0x30 ) {
                                        int j = rbuf[14] & 0x0F;
                                        nr = j > 0 ? j: nr < 0 ? nr : -nr;
                                        if( nr==0 ){
                                            nr=initNr;
                                        }
                                    }
                                    if( DataLength>15 && (rbuf[15]&0xF0)==0x30 ) {
                                        int j = rbuf[15] & 0x0F;
                                        nb = j > 0 ? j: nb < 0 ? nb : -nb;
                                        if( nb==0 ){
                                            nb=initNb;
                                        }
                                    }
                                    if( DataLength>19 && (rbuf[16]&0xE0)==0x60 && (rbuf[17]&0xE0)==0x60 && (rbuf[18]&0xF0)==0x30 && (rbuf[19]&0xE0)==0x60 ) {
                                        LSBbw = (rbuf[16] & 0x1F)+1;
                                        USBbw = (rbuf[17] & 0x1F)+1;
                                        CWbw  = (rbuf[18] & 0x0F)+1;
                                        AMbw  = ((rbuf[19] & 0x1C)>>2)+1;
                                        FMbw  = (rbuf[19] & 0x03)+1;
                                    }
                                    if( DataLength>20 && (rbuf[20]&0xc0)==0x40 ) {
                                        int j = (rbuf[20] & 0x30)>>4;
                                        att = j > 0 ? j: att < 0 ? att : -att;
                                        if( att==0 ){
                                            att=initAtt;
                                        }
                                        j = (rbuf[20] & 0x08)>>3;
                                        lp = j > 0 ? j: lp < 0 ? lp : -lp;
                                        if( lp==0 ){
                                            lp=initLp;
                                        }
                                        j = (rbuf[20] & 0x06)>>1;
                                        an = j > 0 ? j: an < 0 ? an : -an;
                                        if( an==0 ){
                                            an=initAn;
                                        }
                                        j = rbuf[20] & 0x01;
                                        rit=j;
                                    }
                                    if( DataLength>21 ) {
                                        int j=rbuf[21] & 0xFF;
                                        //rssi =  j-192-31+(att>0?12:0);
                                        rssi =  j-192-31+12;
                                        // rssi=(int)yvalues[512];
                                    }
                                     if( DataLength>22 ) {
                                         int j = rbuf[22] & 0x7F;
                                         if( indVol == 0 ) {
                                             volume = j > 0 ? j: volume < 0 ? volume: -volume;
                                             if( volume==0 ) {
                                                 volume = initVolume;
                                             }
                                         } else if( indVol == 1 ) {
                                                 volumeAux = j > 0 ? j: volumeAux < 0 ? volumeAux: -volumeAux;
                                                 if( volumeAux==0 ) {
                                                     volumeAux = initVolumeAux;
                                                 }
                                         } else {
                                             volumeSide = j > 0 ? j : volumeSide < 0 ? volumeSide : -volumeSide;
                                             if (volumeSide == 0) {
                                                 volumeSide = initVolumeSide;
                                             }
                                         }
                                     }
                                     if( DataLength>25 ) {
                                         char pitchStr[] = new char[3];
                                         pitchStr[0] = (char) (rbuf[23] | 0x30);
                                         pitchStr[1] = (char) (rbuf[24] | 0x30);
                                         pitchStr[2] = (char) (rbuf[25] | 0x30);
                                         int j = 0;
                                         j |= pitchStr[0] - 0x30;
                                         for (i = 1; i < 3; i++) {
                                             j <<= 4;
                                             j |= pitchStr[i] - 0x30;
                                         }
                                         pitch=j;
                                     }
                                     if( DataLength>30 ) {
                                         ritStr = new char[6];
                                         ritStr[0] = (char) (rbuf[26] | 0x30);
                                         ritStr[1] = (char) (rbuf[27] | 0x30);
                                         ritStr[2] = (char) (rbuf[28] | 0x30);
                                         ritStr[3] = (char) (rbuf[29] | 0x30);
                                         ritStr[4] = (char) (rbuf[30] | 0x30);
                                         ritStr[5] = (char) 0;
                                         long j=0;
                                         j = 0;
                                         j |= ritStr[0] - 0x30;
                                         if( j>0x07) {
                                             j=j-16;
                                         }
                                         for (i = 1; i < 5; i++) {
                                             j <<= 4;
                                             j |= ritStr[i] - 0x30;
                                         }
                                         ritFreq=j;
                                     }
                                     mHandler.post(new Runnable() {
                                        public void run() {
                                            TextView txtFREQ;
                                            String mRit = "Rit: " + ritFormat.format(ritFreq) + " Hz ";
                                            if( rit == 0 ){
                                                mRit="Rit off ";
                                            }
                                            if( ptt >0 ) {
                                                    txtFREQ = (TextView) findViewById(2000);
                                                    txtFREQ.setBackgroundColor(0xFFFF0000);
                                                    txtFREQ = (TextView) findViewById(2001);
                                                    txtFREQ.setText(mRit);
                                                    txtFREQ.setBackgroundColor(0xFFFF0000);
                                                    txtFREQ = (TextView) findViewById(2002);
                                                    txtFREQ.setText(mFreq);
                                                    txtFREQ.setBackgroundColor(0xFFFF0000);
                                            } else {
                                                if( tune > 0 ) {
                                                    txtFREQ = (TextView) findViewById(2000);
                                                    txtFREQ.setBackgroundColor(0xFF00FF00);
                                                    txtFREQ = (TextView) findViewById(2001);
                                                    txtFREQ.setText(mRit);
                                                    txtFREQ.setBackgroundColor(0xFF00FF00);
                                                    txtFREQ = (TextView) findViewById(2002);
                                                    txtFREQ.setText(mFreq);
                                                    txtFREQ.setBackgroundColor(0xFF00FF00);
                                                } else {
                                                    txtFREQ = (TextView) findViewById(2000);
                                                    txtFREQ.setBackgroundColor(0xFF0000FF);
                                                    txtFREQ = (TextView) findViewById(2001);
                                                    txtFREQ.setText(mRit);
                                                    txtFREQ.setBackgroundColor(0xFF0000FF);
                                                    txtFREQ = (TextView) findViewById(2002);
                                                    txtFREQ.setText(mFreq);
                                                    txtFREQ.setBackgroundColor(0xFF0000FF);
                                                }
                                            }
                                            TextView data = (TextView) findViewById(2004);
                                            if(volume >0 ) {
                                                data.setText("Vol " + Integer.toString(volume));

                                            } else {
                                                data.setText("MUTE");
                                            }
                                            data = (TextView) findViewById(2005);
                                            String pbw;
                                            switch( mode ) {
                                                case 1:
                                                    data.setText("AM");
                                                    pbw = bwAM[AMbw];
                                                    break;
                                                case 2:
                                                    data.setText("LSB");
                                                    pbw = bwSSB[LSBbw];
                                                    break;
                                                case 3:
                                                    data.setText("USB");
                                                    pbw = bwSSB[USBbw];
                                                    break;
                                                case 4:
                                                    data.setText("CW+");
                                                    pbw = bwCW[CWbw];
                                                    break;
                                                case 5:
                                                    data.setText("FM");
                                                    pbw = bwFM[FMbw];
                                                    break;
                                                case 6:
                                                    data.setText("CW-");
                                                    pbw = bwCW[CWbw];
                                                    break;
                                                default:
                                                    pbw="";
                                            }
                                            data = (TextView) findViewById(2003);
                                            data.setText( "BW "+pbw);
                                            data = (TextView) findViewById(2006);
                                            if( nr>0) {
                                                data.setText("NR " + Integer.toString(nr));
                                            } else {
                                                data.setText("NR Off");
                                            }
                                            data = (TextView) findViewById(2007);
                                            if( nb>0) {
                                                data.setText("NB " + Integer.toString(nb));
                                            } else {
                                                data.setText("NB Off");
                                            }
                                            data = (TextView) findViewById(2008);
                                            if( an>0) {
                                                data.setText("AN " + Integer.toString(an));
                                            } else {
                                                data.setText("AN Off");
                                            }
                                            data = (TextView) findViewById(2012);
                                            if( lp<0) {
                                                data.setText("Lp Off");
                                            } else {
                                                data.setText("Lp On");
                                            }
                                            data = (TextView) findViewById(2009);
                                            if( att<0) {
                                                data.setText("Att Off");
                                            } else {
                                                data.setText("Att On");
                                            }
                                            data = (TextView) findViewById(2010);
                                            if( agcAuto==0) {
                                                if( agcAlvl==1 ) {
                                                    data.setText("AGC Slo/"+Integer.toString(agcThr>0?agcThr:0));
                                                } else if( agcAlvl==2 ) {
                                                    data.setText("AGC Med/"+Integer.toString(agcThr>0?agcThr:0));
                                                } else if( agcAlvl==3 ) {
                                                    data.setText("AGC Fst/"+Integer.toString(agcThr>0?agcThr:0));
                                                }
                                            } else {
                                                if( agcMlvl >0 ) {
                                                    data.setText("Gain " + Integer.toString(agcMlvl));
                                                } else {
                                                    data.setText("Gain Off");
                                                }
                                            }
                                            data = (TextView) findViewById(2011);
                                            if( squelch>0) {
                                                data.setText("Squelch " + Integer.toString(squelch));
                                            } else {
                                                data.setText("Squelch Off");
                                            }
                                            int s=(rssi+127)/6;
                                            if( s<0 ) {
                                                s=0;
                                            }
                                            if( s>9 ) {
                                                s=9;
                                            }
                                            int d=rssi+73;
                                            if( d<0 ) {
                                                d=0;
                                            }
                                            String value;
                                            if( d==0 ) {
                                                value="S"+Integer.toString(s);
                                            } else {
                                                value="S"+Integer.toString(s)+"+"+Integer.toString(d);
                                            }
                                            plot sm = (plot) findViewById(300);
                                            sm.NewData(s, d);
                                            sm.refreshDrawableState();
                                            data = (TextView) findViewById(3001);
                                            data.setText(value+"\n"+Integer.toString(rssi)+" dBm");
                                            if( oldfreq!=freq) {
                                                setBand(oldfreq,newBand);
                                                if( newBand!=null ) {
                                                    setAll(newBand,bandButton);
                                                }
                                            }
                                        }
                                    });
                                }
                                break;
                        }//end switch decode command
                        SerialProcessStatus = WAIT_CMD;
                        idx = 0;
                        break;
                } //end switch
            }
        }
    }

    private class mFakeLoopdati extends Thread {
        private InputStream inS;
        private OutputStream outS;

        public mFakeLoopdati(InputStream in, OutputStream out) {
            outS=out;
            inS=in;
        }

        public void run() {
            byte[] myOut = new byte[1030];
            byte[] myState = getMyState();
            myState[0]=0x01; // flag
            myState[1]=0x31; // descriptor
            myState[2]=0x3F; // length
            myState[3]=0x31; // length
            myState[4]=0x30; // length
            myState[5]=0x30; // length
            myState[6]=(byte)0x80; // vfo a
            myState[7]=0x30; // frequency
            myState[8]=0x30; // frequency
            myState[9]=0x3d; // frequency
            myState[10]=0x36; // frequency
            myState[11]=0x3b; // frequency
            myState[12]=0x38; // frequency
            myState[13]=0x3c; // frequency
            myState[14]=0x30; // frequency
            myState[15]=(byte)0x83; // no tune,no split,mode (USB)
            myState[16]=0x4E; // main, aux,st,ptt
            myState[17]=0x40; // squelch
            myState[18]=(byte)0x82; // AGC,MGC
            myState[19]=0x44; // Gain
            myState[20]=0x30; // NR
            myState[21]=0x30; // NB
            myState[22]=0x6F; // BW LSB
            myState[23]=0x6F; // BW USB
            myState[24]=0x33; // BW CW
            myState[25]=0x6C; // BW AM FM
            myState[26]=0x48; // AN RIT
            myState[27]=0x30; // RSSI
            myState[28]=(byte)0xB2; // VOLUME (50)
            myState[29]=0x32; // pitch (750)
            myState[30]=0x33; // pitch
            myState[31]=0x3A; // pitch
            myState[32]=0x30; // RIT (1000)
            myState[33]=0x30; // RIT
            myState[34]=0x30; // RIT
            myState[35]=0x30; // RIT
            myState[36]=0x30; // RIT

            Random r=new Random();
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
            }
            for( ;; ) {
                try {
                    Thread.sleep(150);
                } catch (InterruptedException e) {
                }
                myOut[0] = 0;
                myOut[1] = 0x30;
                myOut[2] = 0x30;
                myOut[3] = 0x30;
                myOut[4] = 0x34;
                myOut[5] = 0x30;
                for (int j = 0; j < 1024; j++) {
                    myOut[6 + j] = (byte) (r.nextInt(10) + 80);
                }
                myState[27] =  (byte) (r.nextInt(10) + 100);
                try {
                    outS.write(myOut);
                    outS.write(myState);
                } catch (IOException e) {
                }
            }
        }
    }
}
